{$A+,B-,D+,E-,F-,G+,I+,L+,N-,O-,P+,Q+,R+,S+,T-,V-,X+,Y+}
(****************************************************************************
 Unit     : Utility.Pas
 Parameter: -
 Rckgabe : -
 Zweck    : Sammlung allgemeingehaltener Utility-Funktionen fr BP7


            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            !!!!!      NACH allen BP-eigenen Units einbinden        !!!!!
            !!!!!  Einige BP-Routinen werden durch bessere ersetzte !!!!!
            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


 Erstellt : Daniel Kuhn, 1994
 Gendert : 16/05/98 Min / Max / DoMenu / ... / Header eingefgt / "Doku"
 Gendert : 26/05/98 GetChars eingefuegt (Makro fr GetChar)
 Gendert : 27/05/98 Teilassemblierung einiger Routinen+Wandlung in Inline
 Gendert : 29/05/98 Objekt TFile eingebaut
 Gendert : 02/06/98 ArrayPos eingebaut, TFile optimiert (nach Andreas Killer)
 Gendert : 07/06/98 Starttimer/Readtimer, TFile optimiert
 Gendert : 02/07/98 Fehler in TFile bei leerer Datei behoben
 Gendert : 20/07/98 Delay -> Wait (IMHO Besser)
 Gendert : 21/07/98 FCopy neu
 Gendert : 29/07/98 Delete gelscht -> War fehlerhaft!
 Gendert : 16/08/98 TRIM: #0#0 ->#0 und #0#32->#32 eingefuegt
 Gendert : 29/09/98 Global ORD(s[0]) durch LENGTH ersetzt, wenn mglich
 Gendert : 01/04/99 TRIMDOS eingebaut (Wie Trim aber nur Anfang & Ende);
 Gendert : 09/04/99 SetEnv eingefuegt
 ****************************************************************************)

unit Utility;

Interface


(**************************       Utilitys        **************************)

PROCEDURE Border(Color : Byte);            {-Randfarbe aendern}   inline($B8/$00/$0B/$5B/$B7/$00/$CD/$10);
FUNCTION  GETCHAR(X,Y :byte) : CHAR;       {1 Zeichen vom Bildschirm lesen}
FUNCTION  GETCHARS(X,Y,len :byte) : string;{x Zeichen vom Bildschirm lesen}
PROCEDURE WriteColor(X,Y,l,Attr:Byte);     {Farbe ndern}
VAR       Dummy : Word;                    {Position des Videosegmentes}

FUNCTION  ZERO(b:longint;len:byte):string;    {Zahl mit Nullen auffllen}
FUNCTION  Max(A, B : Integer) : Integer;   {Greren Wert raussuchen} inline($58/$5B/$39/$D8/$7D/02/$89/$D8);
FUNCTION  Min(A, B : Integer) : Integer;   {Kleineren Wert raussuchen} inline($58/$5B/$39/$D8/$7E/02/$89/$D8);

PROCEDURE KILLCURSOR;                      {Cursor ausschalten}   inline($B8/>$0100/$B9/>$2607/$CD/$10);
PROCEDURE RESTORECURSOR;                   {Cursor wiederanschalten}  inline($B8/>$0100/$B9/>$0506/$CD/$10);

PROCEDURE TPUFFER_LEEREN;                  {Tastaturpuffer leeren}
PROCEDURE TPUFFER_SCHREIBEN(str : STRING); {In den Tastaturpuffer schreiben}

PROCEDURE Beep(a:byte);                    {Piept a-mal (Speaker)}
PROCEDURE STATUSBAR(total,amt:longint;x,y:byte);

procedure StartTimer;                      {Timer zur Zeitmessung starten}
function  ReadTimer:longint;               {Timer auslesen (1/100 Sekunden}

(**************************       String          **************************)

FUNCTION  KSTR(s:string;max:byte) : string;{Bringt String auf Lnge MAX}
FUNCTION  UpCases(CONST S : String) : String; {String upcasen}
FUNCTION  PARAMETERS : STRING;             {Alle Parameter als String}
FUNCTION  POSZ(such,worin:string) : byte;  {letztes Vorkommen im String}
function  ArrayPos(var Buf; BufSize : Word; Substr : String) : Word;
PROCEDURE TRIM(var s:string);              {String zurechtrcken}
PROCEDURE TRIMDOS(var s:string);          {String zurechtrcken (nur Anfang&Ende)}
FUNCTION  WildString(Wild,Norm:String):Boolean; {WildCard-Matching/Strings}
PROCEDURE SetEnv(EnvVar, Value : STRING);  {Environment-Variable setzen}

(**************************       Dateien         **************************)

PROCEDURE Del(s:string);                   {Lscht eine Datei falls vorhanden}
FUNCTION exist(const s:string):boolean;    {Prft ob Datei s existiert}
Function UNIQUENAME:string;                {Gibt 8 einzigartige Buchstaben zurck}
Function UNIQUEHex6:string;                {Gibt 6 einzigartige HexBuchstaben zurck}
Function FCopy(const Source,Dest:String;Append:Boolean):Boolean; {Kopiert eine Datei}

(************************  Men / Fensterverwaltung  ***********************)

const ScreenSize=80*25;                    {Bildschirmgre in Zeichen}
type s77=string[77];
FUNCTION  DoMenu(const l:array of s77):string;  {zeigt Menauswahl mit dem Array}
PROCEDURE GraphikWindow(x1,y1,x2,y2:byte); {Fenster mit Rahmen malen}
FUNCTION  OpenWindow:byte;                 {ffnet ein neues Fenster (Bildschirm sichern)}
PROCEDURE CloseWindow;                     {Schliet das zuletzt geffnete Fenster}

(************************  Ersatz fr BP-Routinen  *************************)

PROCEDURE Wait(ms : Word);                {Rechner+OS-unabhngiges Delay}
{PROCEDURE Delete(VAR S:string; Const Index, Count:byte); {Schnelles DELETE}
PROCEDURE FILLCHAR (VAR dest; count : word; value : byte); {Schnelles 16-Bit Fillchar. 286 bentigt}
PROCEDURE MOVE (VAR src, dest; count : word);{Schnelles 16-bit-MOVE. 286 bentigt}
FUNCTION  KEYPRESSED:boolean;              {KeyPressed mit F11 / F12}
FUNCTION  READKEY : char;                  {ReadKey mit F11 / F12}

{*************** Textfile-Objekt (Kann Dateiende berspringen) *************}

const Arr30000Size=32*1024;
type Arr30000=array[1..Arr30000Size] of char;
     TFile= object
              f:file;       {Dateivariable zum internen Zugriff}
              pos:longint;  {Momentane Position im Puffer (Nchstes zeichen)}
              eof:boolean;  {End of File erreicht?}
              Open:Boolean; {Datei offen?}
              p:^Arr30000;
              psize:word;
              function Reset(const s:string):Boolean; {Reset OK?}
              procedure ReadLn(var s:string);
              procedure Close;
            end;

{***************************************************************************}
CONST scancode : Char = #0;
VAR   Upper : ARRAY[Char] OF Char;         {Uppercase Translation Table}
{***************************************************************************}


Implementation
uses crt,dos;

CONST DelayCount : LongInt = 0;            { Delay cycle counts }
      maxFile = 255;                       {FILES-Wert innerhalb des Programms}
var  puffer: Array[1..maxFile] of Byte;   {Puffer fr FILES}

(****************************************************************************
 Prozedur : WriteColor
 Parameter: X,Y : Koordinaten
            l   : Lnge
            Attr: Neues Farbbyte
 Rckgabe : -
 Zweck    : Einfrben bestimmter Bildschirmteile

 Erstellt : fr FL-Bro Daniel Kuhn
 Gendert : 27/05/98 Teilassemblierung
 Gendert :
 ****************************************************************************)

PROCEDURE WriteColor(X,Y,l,Attr:Byte);
VAR Count,
    Tmp: Integer;
begin
  asm
    mov BX,WindMin
    ADD X,BL        { X   := X + lo(WindMin) }
    ADD Y,BH        { Y   := Y + hi(WindMin) }

    XOR AX,AX       { Tmp := 80*pred(Y)+X-2 }
    MOV AL,Y
    DEC AX

    MOV BX,80
    MUL BX
    mov BL,X
    ADD AX,BX
    SUB AX,2

    Mov Tmp,AX
  end;
  For Count := 1 to l do Mem[dummy:succ((Tmp+Count)shl 1)]:=Attr;
end;

(****************************************************************************
 Prozedur : Beep
 Parameter: a: Anzahl der Tne
 Rckgabe : -
 Zweck    : ber Speaker Piepton erzeugen

 Erstellt : fr RamTest Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

PROCEDURE beep(a:byte);
begin
  for a:=1 to a do begin sound(900); delay(30); nosound; delay(500); end;
end;

(****************************************************************************
 Prozedur : Exist
 Parameter: s: Name der Datei
 Rckgabe : Boolean: Existiert die Datei?
 Zweck    : Prft, ob die angegebene Datei existiert, ohne diese zu ffnen!

 Erstellt : fr RamTest
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION exist(const s:string):boolean;
begin
  exist:=(fsearch(s,'')>'');
end;

(****************************************************************************
 Prozedur : Del
 Parameter: s:Name der Datei
 Rckgabe : -
 Zweck    : Lscht die angegebene Datei.
            Kein Fehler wenn sie nicht existiert!

 Erstellt : fr RamTest Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

PROCEDURE del(s:string);
VAR f:file;
begin
  if exist(s) then
  begin
    assign(f,s);
    erase(f);
  end;
end;

(****************************************************************************
 Prozedur : Zero
 Parameter: b: Eingangszahl
            len: Gewnschte Lnge
 Rckgabe : String: Die Zahl mit Nullen davor
 Zweck    : Fllt eine Zahl vorne mit Nullen auf
            Falls die Zahl lnger ist als len wird sie komplett zurckgegeben

 Erstellt : DK
 Gendert : 27/08/98 DK auf Longint erweitert (Lnge+Vorzeichen)
 Gendert :
 ****************************************************************************)

FUNCTION zero(b:longint;len:byte):string;
VAR s:string[50];
const Nullen:string[20]='00000000000000000000';
begin
  str(b,s);
  if b<0 then delete(s,1,1);
  s:=copy(Nullen,1,len-length(s))+s;
  if b<0 then
  begin
    if s[1]='0' then s[1]:='-'
                else s:='-'+s;
  end;
  zero:=s;
end;

(****************************************************************************
 Prozedur : Move
 Parameter: src: Quelladresse
            dest: Zieladresse
            count: Zahl der zu kopierenden Bytes
 Rckgabe : -
 Zweck    : Kopiert einen Speicherbereich in einen anderen. Schneller als
            das Move von BP, da es mit 16Bit-Kopieren arbeitet

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************)

PROCEDURE move (VAR src, dest; count : word); assembler;
asm
  push ds
    mov bx, count
    mov cx, bx
    shr cx, 1

    les di, dest
    lds si, src
    rep movsw

    and bx, 1
    jz @NoMovsB
    movsb
   @NoMovsB:

  pop ds
end;

(****************************************************************************
 Prozedur : FillChar
 Parameter:
 Rckgabe :
 Zweck    : Schnellerer Ersatz fr das BP-Fillchar

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************)

PROCEDURE FillChar (VAR dest; count : word; value : byte); assembler;
asm
  mov bx, count
  mov cx, bx
  shr cx, 1

  mov al, value
  mov ah, al

  les di, dest
  rep stosw

  and bx, 1
  jz @NoStosB
  stosb
 @NoStosB:
end;

(****************************************************************************
 Prozedur : Parameters
 Parameter: -
 Rckgabe : String: Alle Aufrufparameter
 Zweck    : Schnelle und einfache Methode an alle Aufrufparameter zu kommen

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION PARAMETERS : STRING;
BEGIN
  PARAMETERS := STRING( PTR( PREFIXSEG, $0080 )^ );
END;

(****************************************************************************
 Prozedur : GetVideoSegment
 Parameter: -
 Rckgabe : Word: Segmentadresse des Videosegments
 Zweck    : Unterscheiden zwischen monochromen und normalen Graphikkarten
            fr direkten Zugriff auf den Textbildschirm

            NICHT nach auen durchgefhrt, dafr gibt es die Variable DUMMY

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION GetVideoSegment:Word;
begin
  Asm
    Mov  AH,$0f
    INT  $10;
    Cmp  AL, $07;        { Monochrome? }
    Jne  @No;
    Mov  @Result, $B000;
    Jmp  @Done;
@No:Mov  @Result, $B800;
@Done:
  End;
end;

(****************************************************************************
 Prozedur : Delay
 Parameter: MS: Lnge in Millisekunden
 Rckgabe : -
 Zweck    : Genaueres, relativ Rechner und plattformunabhngiges Delay

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************

PROCEDURE Delay (MS: Word); assembler;
ASM
   STI
   MOV AX, [Seg0040];
   MOV ES, AX;                                        { DOS Data segment }
   MOV SI, 006CH;
   MOV AX, ES:[SI];                                   { Read DOS clock }
@@DifferWait:
   CMP AX, ES:[SI];
   JZ @@DifferWait;                                   { Wait for change }
   MOV AX, ES:[SI];
   MOV CX, 0FFFFH;                                    { Preset count }
@@DifferWait1:
   CMP AX, ES:[SI];
   JNZ @@Differs;                                     { Wait for tick }
   LOOP @@DifferWait1;
@@Differs:
   MOV AX, 0004h;               {Runtergesetzt von 37h wegen Realzeit-Daniel}
   XCHG CX, AX;                                       { Calculate delay }
   NOT AX;
   XOR DX, DX;
   DIV CX;
   MOV WORD PTR [DelayCount], AX;                     { Hold delay count }
   CLI
@@AlreadyInstalled:
   MOV DX, [MS];                                      { Retreive delay }
@@CountLoop:
   OR DX, DX;
   JZ @@Exit;                                         { Zero delay exit }
   XOR SI, SI;
   MOV AX, [Seg0040];                                 { Load address }
   MOV ES, AX;
   MOV AX, ES:[SI];
   MOV CX, WORD PTR [DelayCount];                     { Load delay count }
@@Wait2:
   CMP AX, ES:[SI];
   JNZ @@Over;
   LOOP @@Wait2;                                      { Wait 1ms }
@@Over:
   DEC DX;
   JNZ @@CountLoop;                                   { Repeat 1ms delay }
@@Exit:
END;

(****************************************************************************
 Prozedur : Wait
 Parameter: MS: Lnge in Millisekunden
 Rckgabe : -
 Zweck    : Genaueres, relativ Rechner und plattformunabhngiges Delay
            Besser als das andere?

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************)

var
  WaitOneMS : word; (* Number of loops to do for 1 ms wait. *)
  LoopsPerTick : longint; (* Number of loops per timer tick. *)
  BIOSTick : longint absolute $40:$6C; (* System timer, 18.2/second. *)

{$L WAIT.OBJ}
  procedure Wait(ms : word); external;
  procedure WaitInit; external;


(****************************************************************************
 Prozedur : KStr
 Parameter: s: String
            max: Zahl der Zeichen im Ausgangsstring
 Rckgabe : String: Der lngenvernderte String
 Zweck    : Einen String GENAU auf eine feste Lnge bringen (fr die
            Bildschirmausgabe interessant). Stark optimiert!

 Erstellt : fr FLBro Daniel Kuhn
 Gendert : Pascal.Ger
 Gendert :
 ****************************************************************************)

FUNCTION KStr(s:string;max:byte):string; ASSEMBLER;
asm
      PUSH   DS
      CLD
      LDS    SI, s
      LES    DI, @Result

      XOR    AX, AX
      LODSB
      MOV    CX, AX
      MOV    DL, Max
      MOV    ES:[DI], DL
      INC    DI
      REP    MOVSB

      MOV    CL, Max
      SUB    CL, AL
      JBE    @Exit
      MOV    AL, $20
      REP    STOSB
@Exit:
      POP    DS
END;

(****************************************************************************
 Prozedur : GetChar
 Parameter: X,Y: Koordinaten
 Rckgabe : Char: Das Zeichen an der Koordinate
 Zweck    : Ein Zeichen vm Bildschirm auslesen

 Erstellt : fr FL-Bro Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION GetChar( X,Y :byte ) :CHAR;
var TMP:Word;
BEGIN
  asm
    mov al,y
    xor ah,ah
    dec ax
    mov BX,160
    mul BX

    mov BL,x
    shl BX,1
    dec Bx
    dec Bx
    ADD AX,BX
    MOV Tmp,AX
  end;
  GetChar := CHR(MEM[dummy:Tmp]);
END;

(****************************************************************************
 Prozedur : GetChars
 Parameter: X,Y: Koordinaten
            len: Anzahl der Zeichen, die gelesen werden sollen
 Rckgabe : String: Die Zeichen von der Koordinate(x,y) an
 Zweck    : Mehrere Zeichen vom Bildschirm auslesen

 Erstellt : fr FL-Bro Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION GetChars( X,Y,len :byte ) :STRING;
var s:string;
    i:byte;
BEGIN
  s[0]:=chr(len);
  for i:=1 to len do s[i]:=GetChar(x+i-1,y);
  Getchars:=s;
END;

(****************************************************************************
 Prozedur : Upcases
 Parameter: S: String
 Rckgabe : String: S in Grobuchstaben
 Zweck    : Einen String in Grobuchstaben wandeln
            Funktioniert tabellenbasiert, daher auch Umlaute etc.

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION UpCases(CONST S : String) : String; ASSEMBLER;
  ASM
    LES   SI,@Result         {SS:SI => Result}
    LES   DI,S               {ES:DI => S}
    MOV   CL,ES:[DI]         {Get Length(S)}
    MOV   SS:[SI],CL
    AND   CX,00FFh           {CX = Length(S), ZF Set if Null String}
    JZ    @@Done             {Finished if S is a Null String}
    MOV   BX,OFFSET Upper    {DS:BX => Translation Table}
    INC   DI                 {ES:DI => S[1]}
    INC   SI
    TEST  DI,1               {Is ES:DI on a Word Boundary?}
    JZ    @@Even             {Yes - Ok}
    MOV   AL,ES:[DI]         {No  - Translate 1st Char}
    XLAT
    MOV   SS:[SI],AL
    INC   DI
    INC   SI
    DEC   CX
  @@Even:                    {ES:DI now Alligned on a Word Boundary}
    SHR   CX,1               {CX = Characters Pairs to Translate}
    JZ    @@Last             {Skip if no Character Pairs}
    PUSHF                    {Save Carry Flag - Set of Odd Char Left}
  @@Loop:
    MOV   AX,ES:[DI]         {Translate Next 2 Characters}
    XLAT
    MOV   DL,AL
    MOV   AL,AH
    XLAT
    MOV   DH,AL
    MOV   SS:[SI],DX
    ADD   DI,2
    ADD   SI,2
    DEC   CX
    JNZ   @@Loop             {Repeat for each Pair of Chars}
    POPF                     {Restore Carry Flag}
  @@Last:
    JNC   @@Done             {Finished if No Odd Char to Translate}
    MOV   AL,ES:[DI]         {Translate Last Char}
    XLAT
    MOV   SS:[SI],AL
  @@Done:
  END; {Uppercase}

(****************************************************************************
 Prozedur : ReadKey
 Parameter: -
 Rckgabe : char: Gedrckte taste
 Zweck    : Ersatz fr BP-Readkey. Original-Beschreibung:
            This FUNCTION does what CRT.ReadKey would do, except that it uses
            FUNCTION 10h of int 16h. As FUNCTION 10h does not destroy codes
            XYE0 ( XY<>0 ) which represent extended codes produced by the
            cursor block, the translation to XY00 except for 00E0 has to be
            done here.

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION ReadKey:char; ASSEMBLER;
   ASM
       XOR     AL,AL
       XCHG    AL,ScanCode     { new default: no scancode pending       }
       OR      AL,AL           { old scancode pending ?                 }
       JNZ     @Exit           { if yes, return it                      }
       MOV     AH,10h          { call extended bios FUNCTION            }
       INT     16h
       CMP     AL,0E0h         { is it pseudo-ascii: cursor block ?     }
       JNE     @ChkScan        { no, check for no-ASCIIs                }
       OR      AH,AH           { is it greek 'Alpha' 00E0 ?             }
       JZ      @Exit           { if yes, exit                           }
       XOR     AL,AL           { replace $E0 by 0                       }
   @ChkScan:
       OR      AL,AL           { extended keycode ?                     }
       JNZ     @Exit           { if no, exit                            }
       MOV     ScanCode,AH     { store scancode                         }
       OR      AH,AH           { is it 0 too ?                          }
       JNZ     @Exit           { if no, exit                            }
       MOV     AL,3            { CtrlBreak, return ^C                   }
   @Exit:
   END;

(****************************************************************************
 Prozedur : KeyPressed
 Parameter: -
 Rckgabe : Boolean: Ist eine taste im Tastaturspeicher?
 Zweck    : (Siehe auchReadkey): Ein keypressed-Ersatz, der auch auf F11/F12
            reagiert

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION KeyPressed:boolean;ASSEMBLER;
   ASM
        CMP    ScanCode,0
        JNE    @True
        MOV    AH,11h
        INT    16h
        MOV    AL,FALSE
        JE     @Exit
    @True:
        MOV    AL,TRUE
    @Exit:
   END;

 {TEST-Routine

 FUNCTION Keypressed:boolean;
 begin
   Keypressed:=true;
   writeln('TEST');
   beep(1);
 end;}

(****************************************************************************
 Prozedur : tpuffer_schreiben
 Parameter: Str: Zu schreibender String
 Rckgabe : -
 Zweck    : Gibt einen String in den Tastaturpuffer ein.

 Erstellt : SWAG
 Gendert : Daniel Kuhn - Teilassemblierung
 Gendert :
 ****************************************************************************)

PROCEDURE tpuffer_schreiben(Str : STRING);
VAR i:byte; c:word;
BEGIN
 FOR I := 1 TO length(Str) DO
 begin
   c:=word(str[i]);
   ASM
     MOV CX, c
     MOV AH, 5
     INT $16
   end;
 end;
END;

(****************************************************************************
 Prozedur : tpuffer_leeren
 Parameter: -
 Rckgabe : -
 Zweck    : leert den Tastaturpuffer

 Erstellt : Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

PROCEDURE tpuffer_leeren;
BEGIN
  WHILE KeyPressed DO ReadKey;
END;

(****************************************************************************
 Prozedur : posz
 Parameter: such: Zu suchender String
            worin: Zu durchsuchender String
 Rckgabe : byte: Position des Suchstrings (0= nicht gefunden)
 Zweck    : Sucht in einem String VON HINTEN an nach dem Suchstring

 Erstellt : Nico Wallmeier
 Gendert : Daniel Kuhn - Optimierung
 Gendert :
 ****************************************************************************)

FUNCTION posz(such,worin:string):byte;
VAR i:integer;
BEGIN
 posz:=0;
 {Abfangen: Kann von der Lnge her nicht vorkommen}
 if (length(worin)=0) or (length(worin)<length(such)) then exit;
 {Abfangen leerer zu suchender String}
 if length(such)=0 then begin posz:=1; exit; end;
 for i:=length(worin)-length(such)+1 downto 1 do
   if copy(worin,i,length(such))=such then begin posz:=i; exit; end;
end;

(****************************************************************************
 Prozedur : StatusBar
 Parameter: total : Grtmglicher Wert (entspricht 100%)
            amt   : Momentaner Wert
            x,y   : Position an der er anfangen soll
 Rckgabe : -
 Zweck    : Gibt einen Statusbalken der Lnge 21 aus (zuzglich Beschriftung)

 Erstellt : fr FLBro Daniel Kuhn
 Gendert : 27/05/98 - Fehler bei Total=0 behoben
 Gendert :
 ****************************************************************************)

PROCEDURE StatusBar(total,amt:longint;x,y:byte);
Const
  BarLength=21;
  dup ='';
  dup1='';
VAR
  percent,                 {In Balkenteilen}
  percent2 : integer;      {In Prozent}
  x1,y1:byte;

begin

  x1:=wherex; y1:=wherey;
  If (Amt>=Total) or (total=0) then
  begin
    percent:=barlength;
    percent2:=100;
  end else
  begin
    percent2:=trunc(Amt/total*100);
    Percent:=round((Amt/total)*Barlength);
  end;
  GotoXY(X,Y);
  Write(copy(Dup1,1,percent),copy(dup,1,Barlength-percent),' (',percent2:3,'%)');
  gotoxy(x1,y1);
end;

(****************************************************************************
 Prozedur : Delete
 Parameter: VAR S: Source-String (wird verndert!)
            Index: Startposition
            Count: Anzahl zu lschender Zeichen
 Rckgabe : -
 Zweck    : Lscht aus einem String einen Teil heraus. Schneller als
            BP-Delete

 Erstellt : SWAG
 Gendert :
 Gendert :
 ****************************************************************************

PROCEDURE Delete(VAR S : string; Const Index, Count : byte); assembler;
 asm
    push ds
    mov cl,Count
    or cl,cl
    jz @Exit
    lds ax,S
    les ax,S
    mov bx,ax
    push ax
    mov al,Index
    xor ah,ah
    xor ch,ch
    add ax,cx
    dec ax
    mov cl,byte ptr [bx]
    cmp ax,cx
    pop ax
    ja @Exit
    je @To_End
    mov cl,Index
    xor ch,ch
    add ax,cx
    mov di,ax
    mov cl,Count
    xor ch,ch
    add ax,cx
    mov si,ax
    mov cl,byte ptr [bx]
    sub cl,Count
    xor ch,ch
    or cx,cx
    jz @Empty
    cld
    rep movsb
    mov cl,byte ptr [bx]
    sub cl,Count
 @Empty:
    mov byte ptr [bx],cl
    jmp @Exit
 @To_End:
    mov cl,Index
    dec cl
    mov byte ptr [bx],cl
 @Exit:
    pop ds
 end;

{ Fehlerprfung bei Programmende }*)

(****************************************************************************
 Prozedur : RunTimeExitProc
 Parameter: -
 Rckgabe : -
 Zweck    : Gibt beim Abbruch mit Runtimeerror einen deutschen Klartext dazu
            aus.

 Erstellt : Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

VAR OldExit:pointer;

PROCEDURE RunTimeExitProc; Far;
begin
  ExitProc:=OldExit; { Restore the original exit PROCEDURE }
  if ErrorAddr<>Nil then
    begin
       writeln;
       write('Fehlerklartext: ');
        case ExitCode of
            1:writeln('Ungltiger DOS-Funktionscode');
            2:writeln('Datei nicht gefunden');
            3:writeln('Pfad nicht gefunden');
            4:writeln('Zu viele Dateien geffnet (FILES erhhen!)');
            5:writeln('Dateizugriff verweigert');
            6:writeln('Datei-Handle ungltig');
            8:writeln('Nicht gengend Hauptspeicher frei');
           12:writeln('Dateizugriffscode ungltig');
           15:writeln('Ungltiges Laufwerk');
           16:writeln('Kann aktuelles Verzeichnis nicht lschen');
           17:writeln('Kann nicht ber Laufwerke hinweg umbenennen');
           18:writeln('Keine weiteren Dateien...');
           86:writeln('DR-DOS: Passwortfehler');
          100:writeln('Lesefehler von Datentrger');
          101:writeln('Schreibfehler auf Datentrger');
          102:writeln('Dateivariable nicht mit ASSIGN zugewiesen');
          103:writeln('Datei nicht geffnet');
          104:writeln('Datei nicht fr Eingabe geffnet');
          105:writeln('Datei nicht fr Ausgabe geffnet');
          106:writeln('Ungueltiges Zahlenformat');
          150:writeln('Schreibgeschtztes Laufwerk');
          151:writeln('Peripheriegert unbekannt');
          152:writeln('Laufwerk nicht bereit');
          153:writeln('Befehl unbekannt');
          154:writeln('CRC-Fehler in Daten');
          155:writeln('Laufwerkszugriff mit ungltiger Lngenangabe');
          156:writeln('Suchfehler auf dem Laufwerk');
          157:writeln('Laufwerkstyp unbekannt');
          158:writeln('Sektor nicht gefunden');
          159:writeln('Drucker hat kein Papier mehr');
          160:writeln('Schreibfehler auf Peripheriegert');
          161:writeln('Lesefehler von Peripheriegert');
          162:writeln('Hardwarefehler');
          200:writeln('Division durch 0');
          201:writeln('Bereichsberschreitung');
          202:writeln('Stack-berlauf');
          203:writeln('Heap-berlauf');
          204:writeln('ungltige Zeiger-Operation');
          205:writeln('Fliekomma-berschreitung');
          206:writeln('Fliekomma-Unterschreitung');
          207:writeln('Ungltige Fliekomma-Operation');
          208:writeln('Overlay-Manager nicht installiert');
          209:writeln('Kann ein Overlay nicht laden');
          210:writeln('Objekt nicht initialisiert');
          211:writeln('Aufruf einer abstrakten Methode');
          212:writeln('Stream-Register-Fehler');
          213:writeln('Collection-Index-Bereichsberschreitung ');
          214:writeln('Collection-Index-berschreitung');
          215:writeln('Arithmetik-berlauf');
          216:writeln('Schutzfehler');
          else writeln('- unbekannter Fehler - (', ExitCode,')');
        end;
    end;
end;


(****************************************************************************
 Prozedur : Variable fr Fensterverwaltung

 Erstellt : 16/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)
type WindowData=record
                  Screen:array[1..Screensize] of word;
                  x1,y1,x2,y2,       {Fensterecken}
                  cx,cy:byte;        {Cursorposition}
                end;
     WindowRec=record
                 IsSaved:boolean;
                 IsUsed:boolean;
                 Data:^WindowData;
               end;

VAR Windows:array[1..5] of WindowRec;

(****************************************************************************
 Prozedur : OpenWindow
 Parameter: -
 Rckgabe : Nummer des soeben belegten Fensters (Gar nicht erst versuchen,
            sich die zu merken, braucht man eh nicht)
 Zweck    : Den aktuellen Bildschirm speichern, um ihn spter wiederher-
            zustellen (Bildschirminhalt / Cursorposition / Fenstergre)

 Erstellt : 16/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION OpenWindow:byte;
VAR i:byte;
begin
  i:=1; while (Windows[i].IsUsed) and (i<5) do inc(i); {Freies Fenster suchen}
  if (i=5) and (WIndows[5].IsUsed) then begin OpenWindow:=0; exit end; {Keins frei?}
  OpenWindow:=i;

  Windows[i].isused:=true;
  if memavail>=sizeof(WindowData) then  {Platz da?}
  begin                                 {Ja -> Speichern}
    Windows[i].IsSaved:=true;
    new(Windows[i].Data);
    move(mem[$B800:0],Windows[i].data^.Screen,screensize*2);
    with Windows[i].Data^ do
    begin
      x1:=succ(lo(windmin)); y1:=succ(hi(windmin));
      x2:=succ(lo(windmax)); y2:=succ(hi(windmax));
      cx:=wherex; cy:=wherey;
    end;
  end else Windows[i].IsSaved:=false;   {Nein -> Schade}
end;

(****************************************************************************
 Prozedur : CloseWindow
 Parameter: -
 Rckgabe : -
 Zweck    : Schliet das zuletzt geffnete Fenster wieder. Stellt also den
            Zustand vor dem letzten OpenWindow wieder her

 Erstellt : 16/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

PROCEDURE CloseWindow;
VAR i:integer;
begin
  i:=1; while (Windows[i+1].IsUsed) and (i<5) do inc(i); {Letztes benutztes Fenster suchen}
  if (Windows[i].IsUsed) and (Windows[i].IsSaved) then
  move(Windows[i].data^.screen,mem[$B800:0],screensize*2);
  with Windows[i].data^ do
  begin
    window(x1,y1,x2,y2);
    gotoxy(cx,cy);
  end;
  dispose(Windows[i].data);
  Windows[i].IsUsed:=false;
  Windows[i].IsSaved:=false;
end;

(****************************************************************************
 Prozedur : GraphikWindow
 Parameter: x1,y1: Koordinaten links oben
            x2,y2: Koordinaten rechts unten
 Rckgabe : -
 Zweck    : ffnet ein Fenster mit Rahmen und grauem Hintergrund zu Ausgabe
            im Fenster

 Erstellt : 16/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

PROCEDURE GraphikWindow(x1,y1,x2,y2:byte);
const
  line='';
VAR x,y:byte;
begin
  OpenWindow;

  dec(x1); inc(x2); dec(y1); inc(y2);

  window(1,1,80,25);
  gotoxy(x1,y1);
  textcolor(black);
  textbackground(lightgray);
  write('',copy(line,1,x2-x1-1),'');
  for y:=succ(y1) to pred(y2) do
  begin
    gotoxy(x1,y);
    write(kstr('',x2-x1),'');
  end;
  gotoxy(x1,y2);
  write('',copy(line,1,x2-x1-1));
  {Ecke rechts unten lieber von Hand zeichnen ;-) }
  MEM[$B800:((Y2-1)*160)+((x2 SHL 1)-1)]:=lightgray*16+black;
  MEM[$B800:((Y2-1)*160)+((x2 SHL 1)-2)]:=ord('');

  window(succ(x1),succ(y1),pred(x2),pred(y2));
  clrscr;
  textbackground(black); textcolor(lightgray);
end;

(****************************************************************************
 Prozedur : DoMenu
 Parameter: l: array of s77 (Strings mit der Lnge 77)
 Rckgabe : AString: Ausgewhlte Zeile
 Zweck    : Auswahl einer Zeile aus einem Array als Menfenster

 Erstellt : 16/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

FUNCTION DoMenu(const l:array of s77):string;

VAR Status:record
             count,Lines,
             Width,Height,
             XMin,XMax,
             CMin,CMax,
             CLine,CPos:integer;
           end;
    i:integer;

PROCEDURE redraw(CMove:Integer);
VAR i:integer;
    CPosOld:integer;
begin
  with Status do
  begin
    CPosOld:=CPos;

    {Neue Zeile bestimmen}
    CPos:=CPos+CMove;
    If CPos>count then begin CPos:=count; CLine:=Lines; end else
      If CPos<1 then begin CPos:=1; CLine:=1; end;
    If CPosOld=CPos then exit;

    {Alte Cursor-Zeile lschen}
    gotoxy(1,CLine); write(kstr(l[CPosOld],width));

    {Falls nur eine weitergescrollt werden soll, DOS das machen lassen}
    if (Cline=lines) and (CMove=1) then
    begin
      writeln;
      textbackground(blue); textcolor(lightgray);
      write(kstr(l[CPos],width));
      textbackground(lightgray); textcolor(black);
      exit;
    end;

    {Neue aktive Zeile berechnen}
    CLine:=CLine+CMove;
    If CLine>Lines then CLine:=Lines else
      If CLine<1 then CLine:=1;

    {Bild aufbauen}
    if (CLine=Lines) or (CLine=1) then
    begin
      clrscr;
      for i:=CPos-CLine+1 to Cpos-1 do writeln(l[i]);
      textbackground(blue); textcolor(lightgray);
      write(kstr(l[CPos],width));
      textbackground(lightgray); textcolor(black);
      if CLine<Lines then writeln;
      for i:=CPos+1 to Cpos-CLine+Lines-1 do writeln(l[i]);
      if CLine<Lines then write(kstr(l[CPos-CLine+Lines],width));
    end else
    begin
      textbackground(blue); textcolor(lightgray);
      gotoxy(1,CLine); write(kstr(l[CPos],width));
      textbackground(lightgray); textcolor(black);
    end;
  end;
end;


begin
  killcursor;
  fillchar(Status,sizeof(Status),0);

  with Status do
    begin
      CPos:=1; CLine:=1;

      {Anzahl der Datenstze bestimmen}
      Count:=(sizeof(l) div sizeof(s77))-1;
      while l[count,0]=#0 do dec(count);

      {Breite und horiz. Position bestimmen}
      for i:=1 to count do Width:=Max(Width,length(l[i]));
      XMin:=(80-Width) div 2;
      XMax:=80-XMin;
      if odd(Width) then inc(XMin);

      {Hhe und vert. Position bestimmen}
      if count<23 then Lines:=Count
                  else Lines:=23;
      CMin:=13-(Lines div 2);
      CMax:=13+(Lines div 2);
      if not odd(lines) then dec(CMax);

      {Fenster erstellen lassen}
      GraphikWindow(XMin,CMin,XMax,CMax);

      {Fenster fllen}
      textbackground(blue); textcolor(lightgray);
      writeln(kstr(l[1],width));
      textbackground(lightgray); textcolor(black);
      for i:=2 to Lines-1 do writeln(l[i]);
      write(l[Lines]);
    end;
  repeat
    case readkey of
      #0 : begin
             case readkey of
               #71 : redraw(-Status.Cpos);          {POS1}
               #79 : redraw(Status.count);          {END}
               #72 : redraw(-1);                    {Pfeil oben}
               #80 : redraw(1);                     {Pfeil unten}
               #81 : redraw(Status.Lines-1);        {PgDown}
               #73 : redraw(1-Status.Lines);        {PgUp}
             end;
             continue;
           end;
      #27 : begin DoMenu:=''; break; end;
      #13 : begin DoMenu:=l[Status.CPos]; break; end;
    end;
  until false;
  CloseWindow;
  restorecursor;

end;

(****************************************************************************
 Prozedur : TRIM
 Parameter: var S: Zu formatiertender String
 Rckgabe : -
 Zweck    : Einen String anstndig formatieren
            - Leerzeichen vorne und hinten abschneiden
            - Von doppelte Leerzeichen je eins lschen

 Erstellt : 27/05/98 DK
 Gendert : 16/08/98 DK: #0#0 ->#0
 Gendert :
 ****************************************************************************)

PROCEDURE TRIM(var s:string);
begin
  while (s[0]>#0) and (s[length(s)] in [#32,#0]) do dec(s[0]); {Ende}
  while (s[0]>#0) and (s[1] in [#32,#0])         do delete(s,1,1); {Anfang}
  while (pos('  ',s)>0) do delete(s,pos('  ',s),1); {zweifache Leerstellen}
  while (pos(#0#0,s)>0) do delete(s,pos(#0#0,s),1); {zweifache Leerstellen}
  while (pos(#0#32,s)>0) do delete(s,pos(#0#32,s),1); {zweifache Leerstellen}
end;

PROCEDURE TRIMDOS(var s:string);
begin
  while (s[0]>#0) and (s[length(s)] in [#32,#0]) do dec(s[0]); {Ende}
  while (s[0]>#0) and (s[1] in [#32,#0])         do delete(s,1,1); {Anfang}
end;

(****************************************************************************
 Prozedur : UNIQUENAME
 Parameter: -
 Rckgabe : String: 8 einzigartige Buchstaben ;-) (Fr Dateiname)
 Zweck    :

 Erstellt : 27/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

Function UNIQUENAME:String;
var i:integer;
begin
  UniqueName[0]:=#8;
  for i:=1 to 8 do UniqueName[i]:=chr(65+random(25));
end;

(****************************************************************************
 Prozedur : UNIQUEHex8
 Parameter: -
 Rckgabe : String: 8 einzigartige Hex-Buchstaben ;-) (Fr Dateiname)
 Zweck    : Fido-Area-Kennung (8 Zeichen 0-F)

 Erstellt : 27/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

Function UNIQUEHex6:string;
const a:array[0..14] of char='123456789ABCDEF';
var i:integer;
begin
  UniqueHex6[0]:=#6;
  for i:=1 to 6 do UniqueHex6[i]:=a[random(15)];
end;

(****************************************************************************
 Prozedur : WildString
 Parameter: Wild: WildStringstring
            Norm: Normaler zu testender String
 Rckgabe : Boolean: Sind die "gleich" nach untigen Regeln?
 Zweck    : WildStringvergleich von 2 Strings
            ACHTUNG: Nicht kompatibel zum DOS-Dateien-WildString-System!

            * : Hier knnen beliebig viele Buchstaben stehen (1-255)
            ? : Hier mu genau ein Buchstabe stehen
            Jedes andere Zeichen mu genau an dieser Stelle vorkommen

 Erstellt : 29/05/98 Daniel Kuhn
 Gendert : 28/07/98 Fehler behoben bei * am Ende
 Gendert :
 ****************************************************************************)

Function WildString(Wild,Norm:String):Boolean;
begin
  WildString:=False;  {Bisher: Ungleich}
  if length(Wild)=0 then exit;

  while (length(Norm)>0) and (length(Wild)>0) do
  begin
    case Wild[1] of
      '*': begin
             {Stern am Ende? Gewonnen!}
             if length(wild)=1 then begin WildString:=True; exit; end;
             delete(wild,1,1);
             {Gucken, ob nach dem Stern irgendwie alles zum Stimmen gebracht
              werden kann}
             while (length(norm)>0) do
             begin
               delete(norm,1,1);
               {Hier leider rekursive Suche notwendig :-( }
               If WildString(Wild,Norm) then
               begin
                 WildString:=true; exit;
               end;
             end;
             exit;
           end;
      '?': {Ganz einfach: Je ein Zeichen erledigt :-) };
      else if (Wild[1]<>Norm[1]) then exit; {Sonst: Muss gleich sein!}
    end;
    delete(Wild,1,1); delete(Norm,1,1);
  end;
  while (Wild[1]='*') and (length(Wild)>0) do delete(Wild,1,1);

  WildString:= (length(Wild)=0) and (length(Norm)=0);
end;

(****************************************************************************
 Prozedur : ArrayPos
 Parameter: var Buf: Variable, die durchsucht werden soll
            var BufSize: Groesse des zu durchsuchenden Speicherbereichs
            Substr: Zu suchender String
 Rckgabe : Position im Buf (1. Zeichen=0 Nichtr gefunden=$FFFF)
 Zweck    : Schnelles Durchsuchen eines Arrays nach einem String

 Erstellt : 02/06/98 Daniel Kuhn (von Andreas Killer, Pascal.Ger)
 Gendert :
 Gendert :
 ****************************************************************************)
function ArrayPos(var Buf; BufSize : Word; Substr : String) : Word; Assembler;
asm
    push    ds
    cld
    les     di, Buf
    {-DI in BX sichern}
    mov     bx, di
    mov     cx, BufSize
    lds     si, Substr
    xor     dh, dh
    mov     dl, ds:[si]
    inc     si
    {-Length(SubStr) = 0 ?}
    test    dx, dx
    jz      @@Error
    dec     dx
    {-BufSize < Length(SubStr)?}
    sub     cx, dx
    jbe     @@Error
    lodsb
@@Next:
    {-Durchsuche Buf nach AL}
    repne   scasb
    {-Gefunden ?}
    jne     @@Error
    {-Length(SubStr) > 1 ?}
    test    dx, dx
    jz      @@Found
    {-Rest von SubStr vergleichen}
    push    cx
    push    di
    push    si
    mov     cx,dx
    repe    cmpsb
    pop     si
    pop     di
    pop     cx
    {-Vergleich Ok?}
    jne     @@Next
@@Found:
    {-Position von SubStr in Buf berechnen}
    dec     di
    mov     ax,di
    sub     ax,bx
    jmp     @@Done
@@Error:
    mov     ax, $FFFF
@@Done:
    pop     ds
  end;

(****************************************************************************
 Prozedur : TFile - ein OBJEKT
 Parameter: -
 Rckgabe : -
 Zweck    : komfortabes einlesen von Textdateien, die Dateiendezeichen
            enthalten.
            ACHTUNG: Sehr viel langsamer als BP-Textfiles
                     Braucht 32KB Heap fr Puffer
                     Wie bei BP werden berlange Zeilen abgeschnitten

 Erstellt : 29/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

(****************************************************************************
 Prozedur : TFile.Reset
 Parameter: s: Dateiname
 Rckgabe : Boolean: Konnte die Datei geffnet werden?
 Zweck    : ffnet eine Textdatei zum Auslesen

 Erstellt : 29/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

function TFile.Reset(const s:string):Boolean;
begin
  If Memavail<Arr30000Size then
  begin
    writeln('Nicht gengend Speicher frei um Datei zu ffnen...');
    halt(1);
  end;
  new(p); fillchar(p^,Arr30000Size,0);
  pos:=Arr30000Size+1;
  assign(f,s);
  {$I-} System.reset(f,1); {$I+}
  Open:= IORESULT=0; Reset:=Open;
end;

(****************************************************************************
 Prozedur : TFile.Close
 Parameter: -
 Rckgabe : -
 Zweck    : Schliet die Datei (Gibt 32k Speicher frei!)

 Erstellt : 29/05/98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

procedure TFile.Close;
begin
  if not(Open) then exit;
  system.close(f);
  Open:=false;
  dispose(p);
end;

(****************************************************************************
 Prozedur : TFile.ReadLn
 Parameter: var s: Der zu lesende String
 Rckgabe : -
 Zweck    : Liest eine Zeile (bis #13#10) aus der Datei

 Erstellt : 29/05/98 Daniel Kuhn
 Gendert : 02/06/98 Daniel Kuhn optimiert nach Hinweisen Andreas Killer
 Gendert : 07/06/98 Daniel Kuhn : R-, Q-, S- und anderes als Optimierung
 Gendert : 29/09/98 Daniel Kuhn : Das hab ich lngst rckgngig gemacht!
 ****************************************************************************)

procedure TFile.ReadLn(var s:string);
var spos:word;
  procedure ReloadFullBlock;
    begin
      blockread(f,p^,Arr30000Size,psize);
      Pos:=1;
    end;
begin
  {String zusammenbasteln}
  if pos>Arr30000Size then ReloadFullBlock;{Puffer komplett durch? Nachladen!}
  if psize=0 then begin eof:=true; exit; end;

  spos:=ArrayPos(p^[pos],psize-pos+1,#13#10);
  if spos=$FFFF then                    {Zeilenende nicht gefunden?}
  begin
    s[0]:=chr(min(psize-pos+1,255));    {Kompletten Block -> String}
    move(p^[pos],s[1],length(s));
    ReloadFullBlock;                    {Block nachladen!}
    if psize=0 then exit;               {Dateiende?}
    spos:=ArrayPos(p^[1],psize,#13#10); {Weil pos=1 -> Etwas einfacher}
    if s[0]<#255 then                   {String auffllen}
      move(p^[1],s[length(s)+1],min(spos,255-length(s[0])));
    pos:=spos+3;
    inc(s[0],spos);
    exit;
  end;
  if spos>255 then spos:=255;

  {String in Ausgabestring kopieren}
  s[0]:=chr(spos); move(p^[pos],s[1],spos);
  inc(pos,spos);
  inc(pos,2);
  eof:= (Arr30000Size>PSize) and (pos>PSize);
end;

(****************************************************************************
 Prozedur : StartTimer
 Parameter: -
 Rckgabe : -
 Zweck    : Starten eines Timers zur Zeitmessung
            Benutzt "Ticks since Midnight" zur Zeitmessung.
            Genauigkeit daher 1/18.2s

 Erstellt : 07.06.98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)
 var TimerVar:longint;

 procedure StartTimer;
 begin
  TimerVar:=meml[$0040:$006c]; {System Timer auslesen}
  repeat until TimerVar<>meml[$0040:$006c]; {Warten auf umspringenden Timer}
  TimerVar:=TRUNC(meml[$0040:$006c]/0.182); {Das Ergebnis zurckgeben}
 end;

(****************************************************************************
 Prozedur : ReadTimer
 Parameter: -
 Rckgabe : Gelaufene Zeit in hundertstel Sekunden
 Zweck    : Auslesen des Timers
            Benutzt "Ticks since Midnight" zur Zeitmessung.
            Genauigkeit daher 1/18.2s

 Erstellt : 07.06.98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

 function ReadTimer:longint;
 begin
   Readtimer:=trunc(meml[$0040:$006c]/0.182)-TimerVar;
 end;

(****************************************************************************
 Prozedur : FCopy
 Parameter: Source: Quelldatei
            Dest: Zieldatei
            Append: Soll angehngt werden, wenn Dest bereits existiert?
 Rckgabe : Erfolgreich kopiert?
 Zweck    : Kopieren einer Datei, eventuell mit Anhngen, falls die Zieldatei
            bereits existiert

 Erstellt : 21.07.98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

Function FCopy(const Source,Dest:String;Append:Boolean):Boolean; {Kopiert eine Datei}
var s,d:file;
    a:array[1..1024] of byte;
    i:integer;
begin
  If not exist(Source) then begin FCopy:=false; exit; end;
  assign(s,source); assign(d,dest);
  reset(s,1);
  if Append and exist(Dest) then
  begin
    reset(d,1); seek(d,filesize(d));
  end else rewrite(d,1);
  while not(eof(s)) do
  begin
    blockread(s,a,1024,i);
    blockwrite(d,a,i);
  end;
  close(s); close(d);
end;

(****************************************************************************
 Prozedur : SetEnv
 Parameter: Source: Quelldatei
            Dest: Zieldatei
            Append: Soll angehngt werden, wenn Dest bereits existiert?
 Rckgabe : Erfolgreich kopiert?
 Zweck    : Kopieren einer Datei, eventuell mit Anhngen, falls die Zieldatei
            bereits existiert

 Erstellt : 21.07.98 Daniel Kuhn
 Gendert :
 Gendert :
 ****************************************************************************)

PROCEDURE SetEnv(EnvVar, Value : STRING);
VAR
  Link,
  PrevLink,
  EnvirP   : word;
  Size,
  Scan,
  Where,
  Dif      : integer;
  NewVar,
  OldVar,
  Test     : STRING;

  FUNCTION CheckSpace(Wanted : integer) : boolean;
  BEGIN
    IF wanted + Scan > Size THEN
      inoutres := 8;
    CheckSpace := inoutres = 0;
  END;

BEGIN
  IF inoutres >0 THEN
    Exit;
  FOR Scan := 1 TO Length(EnvVar) DO
    EnvVar[Scan] := UpCase(EnvVar[Scan]);
  EnvVar := EnvVar + '=';
  NewVar := EnvVar + Value + #0;
  link   := PrefixSeg;

  REPEAT
    PrevLink := Link;
    Link := memw [link : $16];
  UNTIL Link = prevlink;

  EnvirP := memw [Link : $2C];
  Size   := memw [Envirp - 1 : $03] * 16;
  Scan   := 0;
  Where  := -1;
  WHILE mem[EnvirP : Scan] <> 0 DO
  BEGIN
    move(mem[EnvirP : scan], Test[1], 255);
    Test[0] := #255;
    Test[0] := chr(pos(#0, Test));
    IF pos(EnvVar, Test) = 1 THEN
    BEGIN
      Where  := Scan;
      OldVar := Test;
    END;
    Scan := Scan + Length(Test);
  END;

  IF Where = -1 THEN
  BEGIN
    Where  := Scan;
    NewVar := NewVar + #0#0#0;
    IF NOT CheckSpace(Length(NewVar)) THEN
      Exit;
  END
  ELSE
  BEGIN
    Dif := Length(NewVar) - Length(OldVar);
    IF Dif > 0 THEN
    BEGIN
      IF NOT CheckSpace(Dif) THEN
        Exit;
      move(mem[EnvirP : Where], mem[EnvirP : Where + Dif], Scan - Where + 3);
    END
    ELSE
    IF Dif < 0 THEN
      move(mem[EnvirP : Where - Dif], mem[EnvirP : Where], Size - Where + Dif);
  END;

  move(NewVar[1], mem[EnvirP : Where], Length(NewVar));
END;


(****************************************************************************
 Prozedur : -
 Parameter: -
 Rckgabe : -
 Zweck    : Initialisierung der Zeichentabelle (UpCases)
            Bildschirmsegmenbt bestimmen
            Files hochsetzen
            RunTimeExitProc anschalten

 Erstellt :
 Gendert :
 Gendert :
 ****************************************************************************)

VAR index: Integer;
begin
  randomize;
  {InitialiseCaseConversion}
  FOR index := 0 TO 255 DO Upper[chr(index)] := System.UpCase(chr(index));
  Upper['']:='';
  Upper['']:='';
  Upper['']:='';
  {Bildschirmsegment suchen}
  Dummy:=GetVideoSegment;
  {FILES hochsetzen}
  For index := 1 to maxFile do puffer[index] := $FF;
  For index := 1 to 5 do puffer[index] := mem[prefixseg:$18 + pred(index)];
  memw[prefixseg:$32] := maxFile;
  memw[prefixseg:$34] := ofs(puffer);
  memw[prefixseg:$36] := seg(puffer);
  {Exitproc einschalten}
  OldExit:=ExitProc;          { Save the original exit PROCEDURE }
  ExitProc:=@RunTimeExitProc; { Insert the RunTime exit PROCEDURE }
  {Delay initialisieren}
  WaitInit;
END.
